﻿'Michael Good, 3/30/2012
'Daniel Fahringer, CPS 115
'
'Computer vs. player in a game of blackjack

Imports System.Threading

Public Class Form1
    Dim cpuCards() As Integer
    Dim playerCards() As Integer
    Dim cpuImage(7) As PictureBox
    Dim playerImage(7) As PictureBox
    Dim cardsLeft() As Integer

    Dim playerTotal, cpuTotal As Integer

    'INITIALIZATION
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'initialize wins in texboxes
        txtCpuWon.Text = CStr(0)
        txtPlayerWon.Text = CStr(0)

        'initalize images
        playerImage(0) = pctYou1
        playerImage(1) = pctYou2
        playerImage(2) = pctYou3
        playerImage(3) = pctYou4
        playerImage(4) = pctYou5
        playerImage(5) = pctYou6
        playerImage(6) = pctYou7
        cpuImage(0) = pctAI1
        cpuImage(1) = pctAI2
        cpuImage(2) = pctAI3
        cpuImage(3) = pctAI4
        cpuImage(4) = pctAI5
        cpuImage(5) = pctAI6
        cpuImage(6) = pctAI7
    End Sub

    'New Game Button
    Private Sub btnDeal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDeal.Click
        gbxComputer.Visible = True
        gbxPlayer.Visible = True

        'start a new game
        startNewGame(cardsLeft, cpuCards, playerCards)
    End Sub

    'Exit Button
    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub

    'Pass Button
    Private Sub btnPass_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPass.Click
        Dim cpuDone As Boolean = False

        'Let the computer finish getting their cards
        Do Until cpuDone
            computerMove(cpuDone)
        Loop

        'Calculate and display results of game
        showCpuImages()
        If (cpuTotal <= 21) Then
            If (cpuTotal < playerTotal) Then
                MsgBox("Congrats, you won!")
                txtPlayerWon.Text = CStr(CInt(txtPlayerWon.Text) + 1)
            ElseIf playerTotal < cpuTotal Then
                MsgBox("Haha you lose!")
                txtCpuWon.Text = CStr(CInt(txtCpuWon.Text) + 1)
            Else
                MsgBox("Oh wow we tied!")
            End If
        End If
    End Sub

    'Hit me button
    Private Sub btnHit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHit.Click
        'deal an extra card to the player
        deal(cardsLeft, playerCards, True)

        'check to see if player is over
        playerTotal = getTotal(playerCards)
        txtYourScore.Text = playerTotal
        If (playerTotal > 21) Then
            MsgBox("You went over!")
            txtCpuWon.Text = CStr(CInt(txtCpuWon.Text) + 1)
            showCpuImages()
        Else
            computerMove(New Boolean)
        End If
    End Sub

    'Begin a new game
    Private Sub startNewGame(ByRef cardsLeft() As Integer, ByRef cpuCards() As Integer, ByRef playerCards() As Integer)
        'reset arrays
        ReDim cardsLeft(0 To 52)
        ReDim playerCards(0)
        ReDim cpuCards(0)

        txtYourScore.Text = ""
        txtAIScore.Text = ""

        'reset deck
        For ctr As Integer = 0 To (cardsLeft.Length - 1) Step 1
            cardsLeft(ctr) = ctr + 1
        Next

        'reset each hand
        cpuImage(0).Image = My.Resources.b1fv
        cpuImage(1).Image = My.Resources.b1fv
        For ctr As Integer = 2 To 6 Step 1
            playerImage(ctr).Visible = False
            cpuImage(ctr).Visible = False
            cpuImage(ctr).Image = My.Resources.b1fv
        Next

        cpuTotal = 0
        playerTotal = 0

        'deal first two cards to each player
        deal(cardsLeft, playerCards, True)
        deal(cardsLeft, cpuCards, False)
        deal(cardsLeft, playerCards, True)
        deal(cardsLeft, cpuCards, False)

        'let the player know how much they have
        playerTotal = getTotal(playerCards)
        txtYourScore.Text = playerTotal
    End Sub

    'Deal a card to the hand that requested it
    Private Sub deal(ByRef cardsLeft() As Integer, ByRef hand() As Integer, ByVal showCard As Boolean)
        Dim card As Integer
        Dim rnd As New Random()

        'takes a card from the stack of cards
        card = rnd.Next(0, cardsLeft.Length - 1)
        hand(hand.Length - 1) = cardsLeft(card)

        'move the rest of the deck after the card is taken out
        For ctr As Integer = card To cardsLeft.Length - 2 Step 1
            cardsLeft(ctr) = cardsLeft(ctr + 1)
        Next
        ReDim Preserve cardsLeft(0 To cardsLeft.Length - 2)

        'set the value of the card to the image value that needs to be displayed
        card = hand(hand.Length - 1)

        'shows the player's card if need be
        If (showCard) Then
            playerImage(hand.Length - 1).Image = My.Resources.ResourceManager.GetObject(CStr(card))
            playerImage(hand.Length - 1).Visible = True
        Else
            cpuImage(hand.Length - 1).Visible = True
        End If

        'prepare the hand for next card dealt
        ReDim Preserve hand(0 To hand.Length)

        'makes sure cards are really randomized
        Thread.Sleep(20)
    End Sub

    'Gets how many points are in a hand
    Private Function getTotal(ByRef hand() As Integer)
        Dim ace As Boolean = False
        Dim cardNum, score As Integer
        score = 0

        For ctr As Integer = 0 To (hand.Length - 2) Step 1
            cardNum = Math.Ceiling(hand(ctr) / 4)
            'factor in everything but the first ace
            Select Case cardNum
                Case 1
                    If Not ace Then
                        ace = True
                    Else 'additional aces must be counted as 1
                        score += 1
                    End If
                Case 2 To 5
                    score += 10
                Case Else
                    score += (15 - cardNum)
            End Select
        Next
        'calculate whether first ace should be 11 or 1

        If ace Then
            If score <= 10 Then
                score += 11
            Else
                score += 1
            End If
        End If
        Return score
    End Function

    'Display AI's hand at end-of-game
    Private Sub showCpuImages()
        For ctr As Integer = 0 To cpuCards.Length - 2 Step 1
            cpuImage(ctr).Image = My.Resources.ResourceManager.GetObject(CStr(cpuCards(ctr)))
        Next
        cpuTotal = getTotal(cpuCards)
        txtAIScore.Text = cpuTotal
    End Sub

    'The artificial intelligence makes it's move
    Private Sub computerMove(ByRef cpuDone As Boolean)
        'as long as you're 14 or less there's a more than 50% chance that you won't go over
        cpuTotal = getTotal(cpuCards)
        If cpuTotal <= 14 Then
            deal(cardsLeft, cpuCards, False)
            cpuTotal = getTotal(cpuCards)
            If (cpuTotal > 21) Then
                showCpuImages()
                MsgBox("Oh no, I'm over!!!")
                txtPlayerWon.Text = CStr(CInt(txtPlayerWon.Text) + 1)
                cpuDone = True
            End If
        Else
            cpuDone = True
        End If
    End Sub
End Class
